-- Gaspard VANDECASTEELE
-- 1.
SELECT `LNAME`,`MEMBER_POSITION`
FROM `STAFF`
ORDER BY `LNAME` DESC, `MEMBER_POSITION` ASC;

-- 2.
SELECT a.STAFF_CODE, a.LNAME, a.FNAME, a.MEMBER_POSITION, SUM(b.HOURS_NBR)
FROM STAFF a, R_IN_FLIGHT b
WHERE a.STAFF_CODE = b.STAFF_CODE
AND b.YEAR_PERIOD = '2020'
GROUP BY STAFF_CODE;

-- 3.
SELECT a.STAFF_CODE, a.LNAME, a.FNAME, a.MEMBER_POSITION, SUM(b.HOURS_NBR), b.YEAR_PERIOD
FROM STAFF a, R_IN_FLIGHT b
WHERE a.STAFF_CODE = b.STAFF_CODE
GROUP BY a.STAFF_CODE, b.YEAR_PERIOD;

-- 4.
SELECT a.LNAME AS 'Manager LNAME', a.FNAME AS 'Manager FNAME' , b.LNAME AS 'Managed LNAME', b.FNAME AS 'Managed FNAME'
FROM STAFF a, STAFF b
WHERE a.STAFF_CODE = b.MANAGER;

-- 5.
SELECT a.* 
FROM STAFF a, R_OBTAIN b, KoLICENSE c, r_allow_pilot d
WHERE a.STAFF_CODE = b.STAFF_CODE
AND b.KoLIC_CODE = c.KoLIC_CODE
AND c.KoLIC_CODE = d.KoLIC_CODE
AND b.OBTAINED < '2021-01-01'
GROUP BY a.STAFF_CODE;

-- or:
SELECT a.*, SUM(b.HOURS_NBR), b.YEAR_PERIOD
FROM STAFF a, R_IN_FLIGHT b
WHERE a.STAFF_CODE = b.STAFF_CODE
AND b.YEAR_PERIOD = '2020'
GROUP BY a.STAFF_CODE, b.YEAR_PERIOD
HAVING SUM(b.HOURS_NBR) > 0;

-- 6.
SELECT a.*, b.*
FROM STAFF a
LEFT JOIN ASSIGNMENTS b ON a.STAFF_CODE = b.STAFF_CODE
WHERE b.STARTING_DATE >= '2021-12-31'
OR b.ENDING_DATE <= '2021-01-01'
OR b.STAFF_CODE IS NULL;

-- 7.
SELECT a.*, b.*
FROM EFF_FLIGHTS a
LEFT JOIN EFF_STOPOVERS b 
	ON a.EFF_FLIGHTS_PK = b.EFF_FLIGHTS_FK
WHERE b.EFF_FLIGHTS_FK IS NULL;

-- 8.
SELECT a.*, b.*
FROM AIRCRAFTS a, KoAIRCRAFT b 
WHERE a.IATA = b.IATA
AND b.AUTONOMY < (
    SELECT MAX(AIRLINK_DISTANCE)
    FROM AIRLINKS
);

-- 9.
SELECT a.*, e.*
FROM STAFF a, ASSIGNMENTS b, CREWS c, 
     EFF_FLIGHTS d, PLAN_DAYFLIGHTS e
WHERE a.STAFF_CODE = b.STAFF_CODE
AND   b.CREW_CODE = c.CREW_CODE
AND   c.CREW_CODE = d.CREW_CODE
AND   d.PLAN_DAYFLIGHTS_FK = e.PLAN_DAYFLIGHTS_PK
AND   e.DAY_NBR >= 6;

-- 10.
SELECT a.*
FROM EFF_FLIGHTS a
WHERE a.OCC_SEATS_QTY != A.RES_SEATS_QTY

-- or..
SELECT a.OCC_SEATS_QTY, b.PLAN_SEATS
FROM EFF_FLIGHTS a, PLAN_DAYFLIGHTS b
WHERE a.PLAN_DAYFLIGHTS_FK = b.PLAN_DAYFLIGHTS_PK
AND a.OCC_SEATS_QTY != b.PLAN_SEATS

-- 11.
SELECT a.*, b.*
FROM PLAN_DAYFLIGHTS a, EFF_FLIGHTS b
WHERE b.PLAN_DAYFLIGHTS_FK = a.PLAN_DAYFLIGHTS_PK
AND a.DAY_NBR >= 6;

-- 12.
SELECT a.FLIGHT_NBR, a.PLAN_SEATS,
       c.CLASS_NAME, b.ESTIMATED_PRICE,
       d.CURR_NAME, a.PLAN_SEATS*b.ESTIMATED_PRICE AS 'EXPECTED PRICE',
       e.OCC_SEATS_QTY*f.PRICE AS 'FINAL PRICE'
FROM PLAN_DAYFLIGHTS a, R_ESTIMATE_PRICE b,
     CLASSES c, CURRENCIES d, EFF_FLIGHTS e,
     TICKETS f
WHERE a.PLAN_DAYFLIGHTS_PK = b.PLAN_DAYFLIGHTS_FK
AND c.CLASS_CODE = b.CLASS_CODE
AND d.CURR_CODE = b.CURR_CODE
AND e.EFF_FLIGHTS_PK = f.EFF_FLIGHTS_FK;

-- 13.
SELECT b.*, COUNT(b.AIRCRAFT_NBR) as 'COUNT'
FROM EFF_FLIGHTS a, AIRCRAFTS b
WHERE a.AIRCRAFT_NBR = b.AIRCRAFT_NBR
GROUP BY b.AIRCRAFT_NBR
ORDER BY COUNT(b.AIRCRAFT_NBR) DESC
LIMIT 5;
